//+------------------------------------------------------------------+
//|                                             Bars_to_the_left.mq4 |
//+------------------------------------------------------------------+
#property copyright "MisterH"


#property indicator_separate_window
#property indicator_buffers 1

extern int window = 20;
int Type = DRAW_HISTOGRAM; //indicator line type
string ______ = "(0 - line, 2 - histo)";
int Width = 1;            //indicator line width
color Color = DarkOrange;       //indicator line color

bool show_bars_num_on_chart = false; //show comment with Bars value in left top corner of chart


double num[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   SetIndexStyle(0,Type,EMPTY,Width,DarkOrange);
   SetIndexBuffer(0,num);
   SetIndexLabel(0,"# bars");
   
   IndicatorShortName("bars to the left:");
   IndicatorDigits(0);
   return;
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
   {
   if (show_bars_num_on_chart) Comment("");
  return;
   }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
   {
   
   if (Bars < 3) { Print("Error: not enough data to calculate"); return; }
   
   if (show_bars_num_on_chart) Comment("Total "+Bars+" bars loaded");
   
   
   int left;
      
   for(int i = (Bars-1) - (IndicatorCounted()-1); i >= 0; i--) //from oldest to the newest
      {
      if (i>=Bars-2) continue; //skip first 2 bars
      
      
      //for(shift=i+1,i=0;shift<=i+window;shift++,i++)
      if (Close[i+1]==Close[i]) left=i+1; //the nearest price is equal
         else
         {
         if (Close[i+1] > Close[i]) //the nearest price is above
            for (left = i+2; left <= i + window; left++)
               if (Close[left]<=Close[i]) break; //looking for moment when price will be equal or below
         
         if (Close[i+1] < Close[i]) //the nearest price is below
            for (left = i+2; left <= i + window; left++) //looking for moment when price will be equal or above
               if (Close[left]>=Close[i]) break;
         }
         
      
      if (left > i + window) //new window max/min
         num[i] = window; //assign window size
      else
         num[i] = left - i; //assign bars to the left num
      }
   return;
  }
//+------------------------------------------------------------------+